/* This file is auto-generated by opts.sh.  */

#ifndef OPTIONS_H
#define OPTIONS_H

/* Set by -Waggregate-return.
   Warn about returning structures, unions or arrays  */
extern int warn_aggregate_return;

/* Set by -Wcast-align.
   Warn about pointer casts which increase alignment  */
extern int warn_cast_align;

/* Set by -Wdeprecated-declarations.
   Warn about uses of __attribute__((deprecated)) declarations  */
extern int warn_deprecated_decl;

/* Set by -Wdisabled-optimization.
   Warn when an optimization pass is disabled  */
extern int warn_disabled_optimization;

/* Set by -Werror.
   Treat all warnings as errors  */
extern int warnings_are_errors;

/* Set by -Wfatal-errors.
   Exit on the first error occurred  */
extern int flag_fatal_errors;

/* Set by -Winline.
   Warn when an inlined function cannot be inlined  */
extern int warn_inline;

/* Set by -Wmissing-noreturn.
   Warn about functions which might be candidates for __attribute__((noreturn))  */
extern int warn_missing_noreturn;

/* Set by -Wpacked.
   Warn when the packed attribute has no effect on struct layout  */
extern int warn_packed;

/* Set by -Wpadded.
   Warn when padding is required to align structure members  */
extern int warn_padded;

/* Set by -Wshadow.
   Warn when one local variable shadows another  */
extern int warn_shadow;

/* Set by -Wswitch.
   Warn about enumerated switches, with no default, missing a case  */
extern int warn_switch;

/* Set by -Wswitch-default.
   Warn about enumerated switches missing a \"default:\" statement  */
extern int warn_switch_default;

/* Set by -Wswitch-enum.
   Warn about all enumerated switches missing a specific case  */
extern int warn_switch_enum;

/* Set by -Wsystem-headers.
   Do not suppress warnings from system headers  */
extern int warn_system_headers;

/* Set by -Wuninitialized.
   Warn about uninitialized automatic variables  */
extern int warn_uninitialized;

/* Set by -Wunreachable-code.
   Warn about code that will never be executed  */
extern int warn_notreached;

/* Set by -Wunused-function.
   Warn when a function is unused  */
extern int warn_unused_function;

/* Set by -Wunused-label.
   Warn when a label is unused  */
extern int warn_unused_label;

/* Set by -Wunused-parameter.
   Warn when a function parameter is unused  */
extern int warn_unused_parameter;

/* Set by -Wunused-value.
   Warn when an expression value is unused  */
extern int warn_unused_value;

/* Set by -Wunused-variable.
   Warn when a variable is unused  */
extern int warn_unused_variable;

/* Set by -fPIC.
   Generate position-independent code if possible (large mode)  */
extern int flag_pic;

/* Set by -fPIE.
   Generate position-independent code for executables if possible (large mode)  */
extern int flag_pie;

/* Set by -fabi-version=.
     */
extern int flag_abi_version;

/* Set by -falign-functions.
   Align the start of functions  */
extern int align_functions;

/* Set by -falign-jumps.
   Align labels which are only reached by jumping  */
extern int align_jumps;

/* Set by -falign-labels.
   Align all labels  */
extern int align_labels;

/* Set by -falign-loops.
   Align the start of loops  */
extern int align_loops;

/* Set by -fargument-alias.
   Specify that arguments may alias each other and globals  */
extern int flag_argument_noalias;

/* Set by -fargument-noalias.
   Assume arguments may alias globals but not each other  */
extern int flag_argument_noalias;

/* Set by -fargument-noalias-global.
   Assume arguments alias neither each other nor globals  */
extern int flag_argument_noalias;

/* Set by -fasynchronous-unwind-tables.
   Generate unwind tables that are exact at each instruction boundary  */
extern int flag_asynchronous_unwind_tables;

/* Set by -fbounds-check.
   Generate code to check bounds before indexing arrays  */
extern int flag_bounds_check;

/* Set by -fbranch-count-reg.
   Replace add, compare, branch with branch on count register  */
extern int flag_branch_on_count_reg;

/* Set by -fbranch-probabilities.
   Use profiling information for branch probabilities  */
extern int flag_branch_probabilities;

/* Set by -fbranch-target-load-optimize.
   Perform branch target load optimization before prologue / epilogue threading  */
extern int flag_branch_target_load_optimize;

/* Set by -fbranch-target-load-optimize2.
   Perform branch target load optimization after prologue / epilogue threading  */
extern int flag_branch_target_load_optimize2;

/* Set by -fbtr-bb-exclusive.
   Restrict target load migration not to re-use registers in any basic block  */
extern int flag_btr_bb_exclusive;

/* Set by -fcaller-saves.
   Save registers around function calls  */
extern int flag_caller_saves;

/* Set by -fcommon.
   Do not put uninitialized globals in the common section  */
extern int flag_no_common;

/* Set by -fcprop-registers.
   Perform a register copy-propagation optimization pass  */
extern int flag_cprop_registers;

/* Set by -fcrossjumping.
   Perform cross-jumping optimization  */
extern int flag_crossjumping;

/* Set by -fcse-follow-jumps.
   When running CSE, follow jumps to their targets  */
extern int flag_cse_follow_jumps;

/* Set by -fcse-skip-blocks.
   When running CSE, follow conditional jumps  */
extern int flag_cse_skip_blocks;

/* Set by -fcx-limited-range.
   Omit range reduction step when performing complex division  */
extern int flag_cx_limited_range;

/* Set by -fdata-sections.
   Place data items into their own section  */
extern int flag_data_sections;

/* Set by -fdefer-pop.
   Defer popping functions args from stack until later  */
extern int flag_defer_pop;

/* Set by -fdelayed-branch.
   Attempt to fill delay slots of branch instructions  */
extern int flag_delayed_branch;

/* Set by -fdelete-null-pointer-checks.
   Delete useless null pointer checks  */
extern int flag_delete_null_pointer_checks;

/* Set by -fdump-unnumbered.
   Suppress output of instruction numbers and line number notes in debugging dumps  */
extern int flag_dump_unnumbered;

/* Set by -feliminate-dwarf2-dups.
   Perform DWARF2 duplicate elimination  */
extern int flag_eliminate_dwarf2_dups;

/* Set by -feliminate-unused-debug-symbols.
   Perform unused type elimination in debug info  */
extern int flag_debug_only_used_symbols;

/* Set by -feliminate-unused-debug-types.
   Perform unused type elimination in debug info  */
extern int flag_eliminate_unused_debug_types;

/* Set by -fexceptions.
   Enable exception handling  */
extern int flag_exceptions;

/* Set by -fexpensive-optimizations.
   Perform a number of minor, expensive optimizations  */
extern int flag_expensive_optimizations;

/* Set by -ffinite-math-only.
   Assume no NaNs or infinities are generated  */
extern int flag_finite_math_only;

/* Set by -ffloat-store.
   Don't allocate floats and doubles in extended-precision registers  */
extern int flag_float_store;

/* Set by -fforce-addr.
   Copy memory address constants into registers before use  */
extern int flag_force_addr;

/* Set by -fforce-mem.
   Copy memory operands into registers before use  */
extern int flag_force_mem;

/* Set by -ffunction-cse.
   Allow function addresses to be held in registers  */
extern int flag_no_function_cse;

/* Set by -ffunction-sections.
   Place each function into its own section  */
extern int flag_function_sections;

/* Set by -fgcse.
   Perform global common subexpression elimination  */
extern int flag_gcse;

/* Set by -fgcse-after-reload.
   Perform global common subexpression elimination after register allocation  */
extern int flag_gcse_after_reload;

/* Set by -fgcse-las.
   Perform redundant load after store elimination in global common subexpression  */
extern int flag_gcse_las;

/* Set by -fgcse-lm.
   Perform enhanced load motion during global common subexpression elimination  */
extern int flag_gcse_lm;

/* Set by -fgcse-sm.
   Perform store motion after global common subexpression elimination  */
extern int flag_gcse_sm;

/* Set by -fguess-branch-probability.
   Enable guessing of branch probabilities  */
extern int flag_guess_branch_prob;

/* Set by -fident.
   Process #ident directives  */
extern int flag_no_ident;

/* Set by -fif-conversion.
   Perform conversion of conditional jumps to branchless equivalents  */
extern int flag_if_conversion;

/* Set by -fif-conversion2.
   Perform conversion of conditional jumps to conditional execution  */
extern int flag_if_conversion2;

/* Set by -finhibit-size-directive.
   Do not generate .size directives  */
extern int flag_inhibit_size_directive;

/* Set by -finline.
   Pay attention to the \"inline\" keyword  */
extern int flag_no_inline;

/* Set by -finline-functions.
   Integrate simple functions into their callers  */
extern int flag_inline_functions;

/* Set by -finline-functions-called-once.
   Integrate functions called once into their callers  */
extern int flag_inline_functions_called_once;

/* Set by -finstrument-functions.
   Instrument function entry and exit with profiling calls  */
extern int flag_instrument_function_entry_exit;

/* Set by -fivopts.
   Optimize induction variables on trees  */
extern int flag_ivopts;

/* Set by -fkeep-inline-functions.
   Generate code for functions even if they are fully inlined  */
extern int flag_keep_inline_functions;

/* Set by -fkeep-static-consts.
   Emit static const variables even if they are not used  */
extern int flag_keep_static_consts;

/* Set by -fleading-underscore.
   Give external symbols a leading underscore  */
extern int flag_leading_underscore;

/* Set by -floop-optimize.
   Perform loop optimizations  */
extern int flag_loop_optimize;

/* Set by -floop-optimize2.
   Perform loop optimizations using the new loop optimizer  */
extern int flag_loop_optimize2;

/* Set by -fmath-errno.
   Set errno after built-in math functions  */
extern int flag_errno_math;

/* Set by -fmem-report.
   Report on permanent memory allocation  */
extern int mem_report;

/* Set by -fmerge-all-constants.
   Attempt to merge identical constants and constant variables  */
extern int flag_merge_constants;

/* Set by -fmerge-constants.
   Attempt to merge identical constants across compilation units  */
extern int flag_merge_constants;

/* Set by -fmodulo-sched.
   Perform SMS based modulo scheduling before the first scheduling pass  */
extern int flag_modulo_sched;

/* Set by -fmove-loop-invariants.
   Move loop invariant computations out of loops  */
extern int flag_move_loop_invariants;

/* Set by -fmudflap.
   Add mudflap bounds-checking instrumentation for single-threaded program.  */
extern int flag_mudflap;

/* Set by -fmudflapir.
   Ignore read operations when inserting mudflap instrumentation.  */
extern int flag_mudflap_ignore_reads;

/* Set by -fmudflapth.
   Add mudflap bounds-checking instrumentation for multi-threaded program.  */
extern int flag_mudflap_threads;

/* Set by -fnon-call-exceptions.
   Support synchronous non-call exceptions  */
extern int flag_non_call_exceptions;

/* Set by -fomit-frame-pointer.
   When possible do not generate stack frames  */
extern int flag_omit_frame_pointer;

/* Set by -foptimize-register-move.
   Do the full register move optimization pass  */
extern int flag_regmove;

/* Set by -foptimize-sibling-calls.
   Optimize sibling and tail recursive calls  */
extern int flag_optimize_sibling_calls;

/* Set by -fpack-struct.
   Pack structure members together without holes  */
extern int flag_pack_struct;

/* Set by -fpcc-struct-return.
   Return small aggregates in memory, not registers  */
extern int flag_pcc_struct_return;

/* Set by -fpeel-loops.
   Perform loop peeling  */
extern int flag_peel_loops;

/* Set by -fpeephole.
   Enable machine specific peephole optimizations  */
extern int flag_no_peephole;

/* Set by -fpeephole2.
   Enable an RTL peephole pass before sched2  */
extern int flag_peephole2;

/* Set by -fpic.
   Generate position-independent code if possible (small mode)  */
extern int flag_pic;

/* Set by -fpie.
   Generate position-independent code for executables if possible (small mode)  */
extern int flag_pie;

/* Set by -fprefetch-loop-arrays.
   Generate prefetch instructions, if available, for arrays in loops  */
extern int flag_prefetch_loop_arrays;

/* Set by -fprofile.
   Enable basic program profiling code  */
extern int profile_flag;

/* Set by -fprofile-arcs.
   Insert arc-based program profiling code  */
extern int profile_arc_flag;

/* Set by -fprofile-values.
   Insert code to profile values of expressions  */
extern int flag_profile_values;

/* Set by -freg-struct-return.
   Return small aggregates in registers  */
extern int flag_pcc_struct_return;

/* Set by -fregmove.
   Enables a register move optimization  */
extern int flag_regmove;

/* Set by -frename-registers.
   Perform a register renaming optimization pass  */
extern int flag_rename_registers;

/* Set by -freorder-blocks.
   Reorder basic blocks to improve code placement  */
extern int flag_reorder_blocks;

/* Set by -freorder-blocks-and-partition.
   Reorder basic blocks and partition into hot and cold sections  */
extern int flag_reorder_blocks_and_partition;

/* Set by -freorder-functions.
   Reorder functions to improve code placement  */
extern int flag_reorder_functions;

/* Set by -frerun-cse-after-loop.
   Add a common subexpression elimination pass after loop optimizations  */
extern int flag_rerun_cse_after_loop;

/* Set by -frerun-loop-opt.
   Run the loop optimizer twice  */
extern int flag_rerun_loop_opt;

/* Set by -freschedule-modulo-scheduled-loops.
   Enable/Disable the traditional scheduling in loops that already passed modulo scheduling  */
extern int flag_resched_modulo_sched;

/* Set by -frounding-math.
   Disable optimizations that assume default FP rounding behavior  */
extern int flag_rounding_math;

/* Set by -fsched-interblock.
   Enable scheduling across basic blocks  */
extern int flag_schedule_interblock;

/* Set by -fsched-spec.
   Allow speculative motion of non-loads  */
extern int flag_schedule_speculative;

/* Set by -fsched-spec-load.
   Allow speculative motion of some loads  */
extern int flag_schedule_speculative_load;

/* Set by -fsched-spec-load-dangerous.
   Allow speculative motion of more loads  */
extern int flag_schedule_speculative_load_dangerous;

/* Set by -fsched-stalled-insns.
   Allow premature scheduling of queued insns  */
extern int flag_sched_stalled_insns;

/* Set by -fsched-stalled-insns-dep.
   Set dependence distance checking in premature scheduling of queued insns  */
extern int flag_sched_stalled_insns_dep;

/* Set by -fsched2-use-superblocks.
   If scheduling post reload, do superblock scheduling  */
extern int flag_sched2_use_superblocks;

/* Set by -fsched2-use-traces.
   If scheduling post reload, do trace scheduling  */
extern int flag_sched2_use_traces;

/* Set by -fschedule-insns.
   Reschedule instructions before register allocation  */
extern int flag_schedule_insns;

/* Set by -fschedule-insns2.
   Reschedule instructions after register allocation  */
extern int flag_schedule_insns_after_reload;

/* Set by -fshared-data.
   Mark data as shared rather than private  */
extern int flag_shared_data;

/* Set by -fsignaling-nans.
   Disable optimizations observable by IEEE signaling NaNs  */
extern int flag_signaling_nans;

/* Set by -fsingle-precision-constant.
   Convert floating point constants to single precision constants  */
extern int flag_single_precision_constant;

/* Set by -fspeculative-prefetching.
   Use value profiling for speculative prefetching  */
extern int flag_speculative_prefetching;

/* Set by -fsplit-ivs-in-unroller.
   Split lifetimes of induction variables when loops are unrolled.  */
extern int flag_split_ivs_in_unroller;

/* Set by -fstack-check.
   Insert stack checking code into the program  */
extern int flag_stack_check;

/* Set by -fstrength-reduce.
   Perform strength reduction optimizations  */
extern int flag_strength_reduce;

/* Set by -fstrict-aliasing.
   Assume strict aliasing rules apply  */
extern int flag_strict_aliasing;

/* Set by -fsyntax-only.
   Check for syntax errors, then stop  */
extern int flag_syntax_only;

/* Set by -ftest-coverage.
   Create data files needed by \"gcov\"  */
extern int flag_test_coverage;

/* Set by -fthread-jumps.
   Perform jump threading optimizations  */
extern int flag_thread_jumps;

/* Set by -ftime-report.
   Report the time taken by each compiler pass  */
extern int time_report;

/* Set by -ftracer.
   Perform superblock formation via tail duplication  */
extern int flag_tracer;

/* Set by -ftrapping-math.
   Assume floating-point operations can trap  */
extern int flag_trapping_math;

/* Set by -ftrapv.
   Trap for signed overflow in addition, subtraction and multiplication  */
extern int flag_trapv;

/* Set by -ftree-based-profiling.
   Use tree-ssa based implementation of profiling  */
extern int flag_tree_based_profiling;

/* Set by -ftree-ccp.
   Enable SSA-CCP optimization on trees  */
extern int flag_tree_ccp;

/* Set by -ftree-ch.
   Enable loop header copying on trees  */
extern int flag_tree_ch;

/* Set by -ftree-combine-temps.
   Coalesce memory temporaries in the SSA->normal pass  */
extern int flag_tree_combine_temps;

/* Set by -ftree-copyrename.
   Replace SSA temporaries with better names in copies.  */
extern int flag_tree_copyrename;

/* Set by -ftree-dce.
   Enable SSA dead code elimination optimization on trees  */
extern int flag_tree_dce;

/* Set by -ftree-dominator-opts.
   Enable dominator optimizations  */
extern int flag_tree_dom;

/* Set by -ftree-dse.
   Enable dead store elimination  */
extern int flag_tree_dse;

/* Set by -ftree-fre.
   Enable Full Redundancy Elimination (FRE) on trees  */
extern int flag_tree_fre;

/* Set by -ftree-loop-im.
   Enable loop invariant motion on trees  */
extern int flag_tree_loop_im;

/* Set by -ftree-loop-ivcanon.
   Create canonical induction variables in loops  */
extern int flag_tree_loop_ivcanon;

/* Set by -ftree-loop-linear.
   Enable linear loop transforms on trees  */
extern int flag_tree_loop_linear;

/* Set by -ftree-loop-optimize.
   Enable loop optimizations on tree level  */
extern int flag_tree_loop_optimize;

/* Set by -ftree-lrs.
   Perform live range splitting during the SSA->normal pass.  */
extern int flag_tree_live_range_split;

/* Set by -ftree-pre.
   Enable SSA-PRE optimization on trees  */
extern int flag_tree_pre;

/* Set by -ftree-sra.
   Perform scalar replacement of aggregates  */
extern int flag_tree_sra;

/* Set by -ftree-ter.
   Replace temporary expressions in the SSA->normal pass  */
extern int flag_tree_ter;

/* Set by -ftree-vectorize.
   Enable loop vectorization on trees  */
extern int flag_tree_vectorize;

/* Set by -funit-at-a-time.
   Compile whole compilation unit at a time  */
extern int flag_unit_at_a_time;

/* Set by -funroll-all-loops.
   Perform loop unrolling for all loops  */
extern int flag_unroll_all_loops;

/* Set by -funroll-loops.
   Perform loop unrolling when iteration count is known  */
extern int flag_unroll_loops;

/* Set by -funsafe-math-optimizations.
   Allow math optimizations that may violate IEEE or ISO standards  */
extern int flag_unsafe_math_optimizations;

/* Set by -funswitch-loops.
   Perform loop unswitching  */
extern int flag_unswitch_loops;

/* Set by -funwind-tables.
   Just generate unwind tables for exception handling  */
extern int flag_unwind_tables;

/* Set by -fvar-tracking.
   Perform variable tracking  */
extern int flag_var_tracking;

/* Set by -fvariable-expansion-in-unroller.
   Apply variable expansion when loops are unrolled.  */
extern int flag_variable_expansion_in_unroller;

/* Set by -fverbose-asm.
   Add extra commentary to assembler output  */
extern int flag_verbose_asm;

/* Set by -fvpt.
   Use expression value profiles in optimizations  */
extern int flag_value_profile_transformations;

/* Set by -fweb.
   Construct webs and split unrelated uses of single variable  */
extern int flag_web;

/* Set by -fwrapv.
   Assume signed arithmetic overflow wraps around  */
extern int flag_wrapv;

/* Set by -fzero-initialized-in-bss.
   Put zero initialized data in the bss section  */
extern int flag_zero_initialized_in_bss;

/* Set by -p.
   Enable function profiling  */
extern int profile_flag;

/* Set by -pedantic.
   Issue warnings needed for strict compliance to the standard  */
extern int pedantic;

/* Set by -quiet.
   Do not display functions compiled or elapsed time  */
extern int quiet_flag;

/* Set by -version.
   Display the compiler's version  */
extern int version_flag;

/* Set by -w.
   Suppress warnings  */
extern int inhibit_warnings;

#define CL_F95        (1 << 0)

enum opt_code
{
  OPT__help,                                 /* --help */
  OPT__param,                                /* --param */
  OPT__target_help,                          /* --target-help */
  OPT__version,                              /* --version */
  OPT_D,                                     /* -D */
  OPT_E,                                     /* -E */
  OPT_G,                                     /* -G */
  OPT_I,                                     /* -I */
  OPT_M,                                     /* -M */
  OPT_O,                                     /* -O */
  OPT_Os,                                    /* -Os */
  OPT_U,                                     /* -U */
  OPT_W,                                     /* -W */
  OPT_Waggregate_return,                     /* -Waggregate-return */
  OPT_Wall,                                  /* -Wall */
  OPT_Wcast_align,                           /* -Wcast-align */
  OPT_Wdeprecated_declarations,              /* -Wdeprecated-declarations */
  OPT_Wdisabled_optimization,                /* -Wdisabled-optimization */
  OPT_Werror,                                /* -Werror */
  OPT_Werror_,                               /* -Werror= */
  OPT_Wextra,                                /* -Wextra */
  OPT_Wfatal_errors,                         /* -Wfatal-errors */
  OPT_Wglobals,                              /* -Wglobals */
  OPT_Wimplicit_interface,                   /* -Wimplicit-interface */
  OPT_Wimplicit_none,                        /* -Wimplicit-none */
  OPT_Winline,                               /* -Winline */
  OPT_Wlarger_than_,                         /* -Wlarger-than- */
  OPT_Wline_truncation,                      /* -Wline-truncation */
  OPT_Wmissing_intent,                       /* -Wmissing-intent */
  OPT_Wmissing_noreturn,                     /* -Wmissing-noreturn */
  OPT_Wno_,                                  /* -Wno= */
  OPT_Wobsolescent,                          /* -Wobsolescent */
  OPT_Wpacked,                               /* -Wpacked */
  OPT_Wpadded,                               /* -Wpadded */
  OPT_Wprecision_loss,                       /* -Wprecision-loss */
  OPT_Wshadow,                               /* -Wshadow */
  OPT_Wstrict_aliasing,                      /* -Wstrict-aliasing */
  OPT_Wstrict_aliasing_,                     /* -Wstrict-aliasing= */
  OPT_Wswitch,                               /* -Wswitch */
  OPT_Wswitch_default,                       /* -Wswitch-default */
  OPT_Wswitch_enum,                          /* -Wswitch-enum */
  OPT_Wsystem_headers,                       /* -Wsystem-headers */
  OPT_Wuninitialized,                        /* -Wuninitialized */
  OPT_Wunreachable_code,                     /* -Wunreachable-code */
  OPT_Wunset_vars,                           /* -Wunset-vars */
  OPT_Wunused,                               /* -Wunused */
  OPT_Wunused_function,                      /* -Wunused-function */
  OPT_Wunused_internal_procs,                /* -Wunused-internal-procs */
  OPT_Wunused_label,                         /* -Wunused-label */
  OPT_Wunused_module_procs,                  /* -Wunused-module-procs */
  OPT_Wunused_module_vars,                   /* -Wunused-module-vars */
  OPT_Wunused_parameter,                     /* -Wunused-parameter */
  OPT_Wunused_target,                        /* -Wunused-target */
  OPT_Wunused_types,                         /* -Wunused-types */
  OPT_Wunused_value,                         /* -Wunused-value */
  OPT_Wunused_variable,                      /* -Wunused-variable */
  OPT_Wunused_vars,                          /* -Wunused-vars */
  OPT_aux_info,                              /* -aux-info */
  OPT_aux_info_,                             /* -aux-info= */
  OPT_auxbase,                               /* -auxbase */
  OPT_auxbase_strip,                         /* -auxbase-strip */
  OPT_cpp,                                   /* -cpp */
  OPT_d,                                     /* -d */
  OPT_d8,                                    /* -d8 */
  OPT_dumpbase,                              /* -dumpbase */
  OPT_fPIC,                                  /* -fPIC */
  OPT_fPIE,                                  /* -fPIE */
  OPT_fabi_version_,                         /* -fabi-version= */
  OPT_falign_functions,                      /* -falign-functions */
  OPT_falign_functions_,                     /* -falign-functions= */
  OPT_falign_jumps,                          /* -falign-jumps */
  OPT_falign_jumps_,                         /* -falign-jumps= */
  OPT_falign_labels,                         /* -falign-labels */
  OPT_falign_labels_,                        /* -falign-labels= */
  OPT_falign_loops,                          /* -falign-loops */
  OPT_falign_loops_,                         /* -falign-loops= */
  OPT_fargument_alias,                       /* -fargument-alias */
  OPT_fargument_noalias,                     /* -fargument-noalias */
  OPT_fargument_noalias_global,              /* -fargument-noalias-global */
  OPT_fasynchronous_unwind_tables,           /* -fasynchronous-unwind-tables */
  OPT_fbackslash,                            /* -fbackslash */
  OPT_fbounds_check,                         /* -fbounds-check */
  OPT_fbranch_count_reg,                     /* -fbranch-count-reg */
  OPT_fbranch_probabilities,                 /* -fbranch-probabilities */
  OPT_fbranch_target_load_optimize,          /* -fbranch-target-load-optimize */
  OPT_fbranch_target_load_optimize2,         /* -fbranch-target-load-optimize2 */
  OPT_fbtr_bb_exclusive,                     /* -fbtr-bb-exclusive */
  OPT_fc_binding,                            /* -fc-binding */
  OPT_fcall_saved_,                          /* -fcall-saved- */
  OPT_fcall_used_,                           /* -fcall-used- */
  OPT_fcaller_saves,                         /* -fcaller-saves */
  OPT_fcase_upper,                           /* -fcase-upper */
  OPT_fcommon,                               /* -fcommon */
  OPT_fcprop_registers,                      /* -fcprop-registers */
  OPT_fcrossjumping,                         /* -fcrossjumping */
  OPT_fcse_follow_jumps,                     /* -fcse-follow-jumps */
  OPT_fcse_skip_blocks,                      /* -fcse-skip-blocks */
  OPT_fcx_limited_range,                     /* -fcx-limited-range */
  OPT_fd_comment,                            /* -fd-comment */
  OPT_fdata_sections,                        /* -fdata-sections */
  OPT_fdefer_pop,                            /* -fdefer-pop */
  OPT_fdelayed_branch,                       /* -fdelayed-branch */
  OPT_fdelete_null_pointer_checks,           /* -fdelete-null-pointer-checks */
  OPT_fdiagnostics_show_location_,           /* -fdiagnostics-show-location= */
  OPT_fdollar_ok,                            /* -fdollar-ok */
  OPT_fdump_,                                /* -fdump- */
  OPT_fdump_unnumbered,                      /* -fdump-unnumbered */
  OPT_feliminate_dwarf2_dups,                /* -feliminate-dwarf2-dups */
  OPT_feliminate_unused_debug_symbols,       /* -feliminate-unused-debug-symbols */
  OPT_feliminate_unused_debug_types,         /* -feliminate-unused-debug-types */
  OPT_fendian_,                              /* -fendian= */
  OPT_fexceptions,                           /* -fexceptions */
  OPT_fexpensive_optimizations,              /* -fexpensive-optimizations */
  OPT_ffast_math,                            /* -ffast-math */
  OPT_ffinite_math_only,                     /* -ffinite-math-only */
  OPT_ffixed_,                               /* -ffixed- */
  OPT_ffixed_form,                           /* -ffixed-form */
  OPT_ffixed_line_length_132,                /* -ffixed-line-length-132 */
  OPT_ffixed_line_length_80,                 /* -ffixed-line-length-80 */
  OPT_ffloat_store,                          /* -ffloat-store */
  OPT_fforce_addr,                           /* -fforce-addr */
  OPT_fforce_mem,                            /* -fforce-mem */
  OPT_ffree_form,                            /* -ffree-form */
  OPT_ffree_line_length_huge,                /* -ffree-line-length-huge */
  OPT_ffunction_cse,                         /* -ffunction-cse */
  OPT_ffunction_sections,                    /* -ffunction-sections */
  OPT_fgcse,                                 /* -fgcse */
  OPT_fgcse_after_reload,                    /* -fgcse-after-reload */
  OPT_fgcse_las,                             /* -fgcse-las */
  OPT_fgcse_lm,                              /* -fgcse-lm */
  OPT_fgcse_sm,                              /* -fgcse-sm */
  OPT_fguess_branch_probability,             /* -fguess-branch-probability */
  OPT_fident,                                /* -fident */
  OPT_fif_conversion,                        /* -fif-conversion */
  OPT_fif_conversion2,                       /* -fif-conversion2 */
  OPT_fimplicit_none,                        /* -fimplicit-none */
  OPT_finhibit_size_directive,               /* -finhibit-size-directive */
  OPT_finline,                               /* -finline */
  OPT_finline_functions,                     /* -finline-functions */
  OPT_finline_functions_called_once,         /* -finline-functions-called-once */
  OPT_finline_limit_,                        /* -finline-limit- */
  OPT_finline_limit_eq,                        /* -finline-limit= */
  OPT_finstrument_functions,                 /* -finstrument-functions */
  OPT_finteger_,                             /* -finteger= */
  OPT_fintrinsic_extensions,                 /* -fintrinsic-extensions */
  OPT_fintrinsic_extensions_,                /* -fintrinsic-extensions= */
  OPT_fivopts,                               /* -fivopts */
  OPT_fkeep_inline_functions,                /* -fkeep-inline-functions */
  OPT_fkeep_static_consts,                   /* -fkeep-static-consts */
  OPT_fleading_underscore,                   /* -fleading-underscore */
  OPT_flogical_,                             /* -flogical= */
  OPT_floop_optimize,                        /* -floop-optimize */
  OPT_floop_optimize2,                       /* -floop-optimize2 */
  OPT_fmath_errno,                           /* -fmath-errno */
  OPT_fmem_report,                           /* -fmem-report */
  OPT_fmerge_all_constants,                  /* -fmerge-all-constants */
  OPT_fmerge_constants,                      /* -fmerge-constants */
  OPT_fmessage_length_,                      /* -fmessage-length= */
  OPT_fmod_,                                 /* -fmod= */
  OPT_fmodule_private,                       /* -fmodule-private */
  OPT_fmodulo_sched,                         /* -fmodulo-sched */
  OPT_fmove_loop_invariants,                 /* -fmove-loop-invariants */
  OPT_fmudflap,                              /* -fmudflap */
  OPT_fmudflapir,                            /* -fmudflapir */
  OPT_fmudflapth,                            /* -fmudflapth */
  OPT_fmultiple_save,                        /* -fmultiple-save */
  OPT_fnon_call_exceptions,                  /* -fnon-call-exceptions */
  OPT_fomit_frame_pointer,                   /* -fomit-frame-pointer */
  OPT_fone_error,                            /* -fone-error */
  OPT_fonetrip,                              /* -fonetrip */
  OPT_foptimize_register_move,               /* -foptimize-register-move */
  OPT_foptimize_sibling_calls,               /* -foptimize-sibling-calls */
  OPT_fpack_derived,                         /* -fpack-derived */
  OPT_fpack_struct,                          /* -fpack-struct */
  OPT_fpack_struct_,                         /* -fpack-struct= */
  OPT_fpcc_struct_return,                    /* -fpcc-struct-return */
  OPT_fpeel_loops,                           /* -fpeel-loops */
  OPT_fpeephole,                             /* -fpeephole */
  OPT_fpeephole2,                            /* -fpeephole2 */
  OPT_fpic,                                  /* -fpic */
  OPT_fpie,                                  /* -fpie */
  OPT_fpointer_,                             /* -fpointer= */
  OPT_fprefetch_loop_arrays,                 /* -fprefetch-loop-arrays */
  OPT_fprofile,                              /* -fprofile */
  OPT_fprofile_arcs,                         /* -fprofile-arcs */
  OPT_fprofile_generate,                     /* -fprofile-generate */
  OPT_fprofile_use,                          /* -fprofile-use */
  OPT_fprofile_values,                       /* -fprofile-values */
  OPT_fqkind_,                               /* -fqkind= */
  OPT_frandom_seed,                          /* -frandom-seed */
  OPT_frandom_seed_,                         /* -frandom-seed= */
  OPT_freal_,                                /* -freal= */
  OPT_freg_struct_return,                    /* -freg-struct-return */
  OPT_fregmove,                              /* -fregmove */
  OPT_frename_registers,                     /* -frename-registers */
  OPT_freorder_blocks,                       /* -freorder-blocks */
  OPT_freorder_blocks_and_partition,         /* -freorder-blocks-and-partition */
  OPT_freorder_functions,                    /* -freorder-functions */
  OPT_frerun_cse_after_loop,                 /* -frerun-cse-after-loop */
  OPT_frerun_loop_opt,                       /* -frerun-loop-opt */
  OPT_freschedule_modulo_scheduled_loops,    /* -freschedule-modulo-scheduled-loops */
  OPT_fround_,                               /* -fround= */
  OPT_frounding_math,                        /* -frounding-math */
  OPT_fsched_interblock,                     /* -fsched-interblock */
  OPT_fsched_spec,                           /* -fsched-spec */
  OPT_fsched_spec_load,                      /* -fsched-spec-load */
  OPT_fsched_spec_load_dangerous,            /* -fsched-spec-load-dangerous */
  OPT_fsched_stalled_insns,                  /* -fsched-stalled-insns */
  OPT_fsched_stalled_insns_dep,              /* -fsched-stalled-insns-dep */
  OPT_fsched_stalled_insns_dep_,             /* -fsched-stalled-insns-dep= */
  OPT_fsched_stalled_insns_,                 /* -fsched-stalled-insns= */
  OPT_fsched_verbose_,                       /* -fsched-verbose= */
  OPT_fsched2_use_superblocks,               /* -fsched2-use-superblocks */
  OPT_fsched2_use_traces,                    /* -fsched2-use-traces */
  OPT_fschedule_insns,                       /* -fschedule-insns */
  OPT_fschedule_insns2,                      /* -fschedule-insns2 */
  OPT_fsecond_underscore,                    /* -fsecond-underscore */
  OPT_fshared_data,                          /* -fshared-data */
  OPT_fshort_circuit,                        /* -fshort-circuit */
  OPT_fsignaling_nans,                       /* -fsignaling-nans */
  OPT_fsingle_precision_constant,            /* -fsingle-precision-constant */
  OPT_fsloppy_char,                          /* -fsloppy-char */
  OPT_fspeculative_prefetching,              /* -fspeculative-prefetching */
  OPT_fsplit_ivs_in_unroller,                /* -fsplit-ivs-in-unroller */
  OPT_fstack_check,                          /* -fstack-check */
  OPT_fstack_limit,                          /* -fstack-limit */
  OPT_fstack_limit_register_,                /* -fstack-limit-register= */
  OPT_fstack_limit_symbol_,                  /* -fstack-limit-symbol= */
  OPT_fstatic,                               /* -fstatic */
  OPT_fstrength_reduce,                      /* -fstrength-reduce */
  OPT_fstrict_aliasing,                      /* -fstrict-aliasing */
  OPT_fsyntax,                               /* -fsyntax */
  OPT_fsyntax_only,                          /* -fsyntax-only */
  OPT_ftest_coverage,                        /* -ftest-coverage */
  OPT_fthread_jumps,                         /* -fthread-jumps */
  OPT_ftime_report,                          /* -ftime-report */
  OPT_ftls_model_,                           /* -ftls-model= */
  OPT_ftr15581,                              /* -ftr15581 */
  OPT_ftrace_,                               /* -ftrace= */
  OPT_ftracer,                               /* -ftracer */
  OPT_ftrapping_math,                        /* -ftrapping-math */
  OPT_ftrapv,                                /* -ftrapv */
  OPT_ftree_based_profiling,                 /* -ftree-based-profiling */
  OPT_ftree_ccp,                             /* -ftree-ccp */
  OPT_ftree_ch,                              /* -ftree-ch */
  OPT_ftree_combine_temps,                   /* -ftree-combine-temps */
  OPT_ftree_copyrename,                      /* -ftree-copyrename */
  OPT_ftree_dce,                             /* -ftree-dce */
  OPT_ftree_dominator_opts,                  /* -ftree-dominator-opts */
  OPT_ftree_dse,                             /* -ftree-dse */
  OPT_ftree_fre,                             /* -ftree-fre */
  OPT_ftree_loop_im,                         /* -ftree-loop-im */
  OPT_ftree_loop_ivcanon,                    /* -ftree-loop-ivcanon */
  OPT_ftree_loop_linear,                     /* -ftree-loop-linear */
  OPT_ftree_loop_optimize,                   /* -ftree-loop-optimize */
  OPT_ftree_lrs,                             /* -ftree-lrs */
  OPT_ftree_pre,                             /* -ftree-pre */
  OPT_ftree_sra,                             /* -ftree-sra */
  OPT_ftree_ter,                             /* -ftree-ter */
  OPT_ftree_vectorize,                       /* -ftree-vectorize */
  OPT_ftree_vectorizer_verbose_,             /* -ftree-vectorizer-verbose= */
  OPT_funderscoring,                         /* -funderscoring */
  OPT_funit_at_a_time,                       /* -funit-at-a-time */
  OPT_funroll_all_loops,                     /* -funroll-all-loops */
  OPT_funroll_loops,                         /* -funroll-loops */
  OPT_funsafe_math_optimizations,            /* -funsafe-math-optimizations */
  OPT_funswitch_loops,                       /* -funswitch-loops */
  OPT_funwind_tables,                        /* -funwind-tables */
  OPT_fvar_tracking,                         /* -fvar-tracking */
  OPT_fvariable_expansion_in_unroller,       /* -fvariable-expansion-in-unroller */
  OPT_fverbose_asm,                          /* -fverbose-asm */
  OPT_fvisibility_,                          /* -fvisibility= */
  OPT_fvpt,                                  /* -fvpt */
  OPT_fweb,                                  /* -fweb */
  OPT_fwrapv,                                /* -fwrapv */
  OPT_fzero,                                 /* -fzero */
  OPT_fzero_initialized_in_bss,              /* -fzero-initialized-in-bss */
  OPT_g,                                     /* -g */
  OPT_gcoff,                                 /* -gcoff */
  OPT_gdwarf_2,                              /* -gdwarf-2 */
  OPT_ggdb,                                  /* -ggdb */
  OPT_gstabs,                                /* -gstabs */
  OPT_gstabs_,                               /* -gstabs+ */
  OPT_gvms,                                  /* -gvms */
  OPT_gxcoff,                                /* -gxcoff */
  OPT_gxcoff_,                               /* -gxcoff+ */
  OPT_i4,                                    /* -i4 */
  OPT_i8,                                    /* -i8 */
  OPT_m,                                     /* -m */
  OPT_max_frame_size_,                       /* -max-frame-size= */
  OPT_no_cpp,                                /* -no-cpp */
  OPT_nontraditional,                        /* -nontraditional */
  OPT_o,                                     /* -o */
  OPT_p,                                     /* -p */
  OPT_pedantic,                              /* -pedantic */
  OPT_pedantic_errors,                       /* -pedantic-errors */
  OPT_quiet,                                 /* -quiet */
  OPT_r10,                                   /* -r10 */
  OPT_r8,                                    /* -r8 */
  OPT_std_F,                                 /* -std=F */
  OPT_std_f2003,                             /* -std=f2003 */
  OPT_std_f95,                               /* -std=f95 */
  OPT_traditional,                           /* -traditional */
  OPT_version,                               /* -version */
  OPT_w,                                     /* -w */
  N_OPTS
};

#endif /* OPTIONS_H */
